

/**
 * Author:Taras Kyrychuk 
 * date:10/03/2021
 * version: 1.0
 * 
 */
 

#include <avr/sleep.h>//this AVR library contains the methods that controls the sleep modes

#define LED_PWM 0
#define LED_IND 3
boolean state = false;
boolean flagIn = false;
boolean flagwake = false;
boolean timevarpin = 0;
boolean flagled = false;
int wakeup_counter = 0;
int brightness = 0;
unsigned long startTime = 0;
unsigned long varTime;
#define But_in 1
#define Vartime_in 4

void setup() {
  
  pinMode(LED_IND,OUTPUT);//We use the led on pin  to indecate when Arduino is A sleep
  pinMode(But_in,INPUT_PULLUP);//Set pin  to input using the buildin pullup resistor
  pinMode(Vartime_in,INPUT);//Set pin  to input
  pinMode(LED_PWM,OUTPUT);//use pin B0
  pinMode(2,INPUT_PULLUP);
  digitalWrite(LED_IND,HIGH);//turning LED on
  ADCSRA &= ~(1 << ADEN); // ADC off
  ACSR |= (1 << ACD); 	// AC off
}

void Going_To_Sleep(){
    sleep_enable();//Enabling sleep mode
    attachInterrupt(0, wakeUp, LOW);//attaching a interrupt to pin B1
    set_sleep_mode(SLEEP_MODE_PWR_DOWN);//Setting the sleep mode, in our case full sleep
    digitalWrite(LED_IND,LOW);//turning LED off
    pinMode(Vartime_in,OUTPUT);//Set pin  to input disable buildin pullup resistor
    digitalWrite(Vartime_in,LOW);
    delay(1000); //wait a second to allow the led to be turned off before going to sleep
    sleep_cpu();//activating sleep mode 
    }

void wakeUp(){
  
  sleep_disable();//Disable sleep mode
  detachInterrupt(0); //Removes the interrupt from pin B1;
  wakeup_counter++;
  flagwake = true;
  brightness = 255;
  state = true; //work
  digitalWrite(LED_IND,HIGH);//turning LED on
  
  if (wakeup_counter == 2){
  flagIn = false;
  flagwake = false;
  flagled = true;          //knop second pressed
  analogWrite(LED_PWM,0);//LED_light off for blink  
  } else {
  pinMode(Vartime_in,INPUT_PULLUP);//Set pin  to input using the buildin pullup resistor
  analogWrite(LED_PWM,brightness);
  delay(500); 
  }
  delay(1500); 
  
  timevarpin = digitalRead(Vartime_in);
    if (timevarpin == LOW) {
    varTime = 180;
    } else {
    varTime = 600;  
    }

}



void loop() { 
   if (flagwake == true) {  
    attachInterrupt(0, wakeUp, LOW);//attaching a interrupt to pin B1
    flagwake = false;
    }
     
   switch (wakeup_counter){
    case 1:
    
    digitalWrite(LED_IND,LOW);//turning LED off
    delay(500);
    digitalWrite(LED_IND,HIGH);//turning LED on
    delay(499);
    startTime++;
    if (startTime >= varTime) {
    flagIn = true;
    startTime = 0;
    wakeup_counter = 2;
    }
     break;
    
    case 2:
    if (flagIn == true) {
    detachInterrupt(0); //Removes the interrupt from pin B1;
    flagIn = false;
    }
    if (flagled == true) {
    digitalWrite(LED_IND,HIGH);
    flagled = false;
    }
    brightness--;
    delay(75);
    if (brightness == 0) { 
    state = false;
    }
     break;
     
    default:
    break;
    
   }
    
    if (state == true) {
    analogWrite(LED_PWM,brightness); // LED ON 
    } else {
    brightness = 0;
    analogWrite(LED_PWM,brightness); // LED OFF
    wakeup_counter = 0;
    Going_To_Sleep();
    }
}
